/*
 * @(#)SadissComboBoxEditor.java 1.0 10/24/2002
 * Copyright 2002 Senamirmir Project
 *
 * You may distribute and/or modify Sadiss under the conditions 
 * of the LaTeX Project Public License. The license is located at
 * http://www.latex-project.org/lppl.txt
 */

package keffa ;

import java.awt.*; 
import java.awt.event.*; 
import javax.swing.* ;
import javax.swing.text.* ;
import javax.swing.event.* ;
import java.beans.*; 
import java.util.*; 
import java.io.*; 
import java.net.*; 
import java.util.* ;
 
/**
 * <!-- ----------------------------------------------------------------------- -->
 * SadissHelp inherits JInternalFrame. Its content is JEditPane which is used 
 * for help. The format of the content is HTML.
 * @author abass alamnehe
 * @version 1.0 10/24/2002
 * <!-- ----------------------------------------------------------------------- -->
 */

public class SadissHelp extends JInternalFrame implements ActionListener {   
   SadissHtmlPane html;          
   static int visited = 0 ;
   static int size = 0 ;
   JButton backButton ;     
   JButton forwardButton ;
   JButton homeButton ;
   String[] icons = {"keffa/icons/Help16.gif","keffa/icons/Home16.gif",
                     "keffa/icons/Back16.gif","keffa/icons/Forward16.gif"} ;
   String home = "help/index.htm" ;
   LinkedList list = new LinkedList() ;

   /** 
    * SadissHelp Constructor 
    */ 
   public SadissHelp() {
      super("Help", true, true, true, true) ;
      setSize(500, 600) ;
      
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      setLocation(screenSize.width - 550, 10) ;     
      setFrameIcon(new ImageIcon(icons[0])) ;

      try { 
         URL url = null; 
         String path = null; 
         try { 
            path = home ;
            url = getClass().getResource(path);
            list.add(url) ;                      // add home page to list
         } catch (Exception e) { 
            System.err.println("Failed to open " + path); 
            url = null; 
         } 

         if (url != null) { 
            html = new SadissHtmlPane(url) ; 
            html.setEditable(false) ; 
            html.addHyperlinkListener(createHyperLinkListener()) ; 
            
            JScrollPane jsp = new JScrollPane() ; 
            JViewport vp = jsp.getViewport() ; 
            vp.add(html) ; 

            JToolBar toolBar = new JToolBar() ;
            homeButton = new JButton(
                     new ImageIcon( ClassLoader.getSystemResource(icons[1])) ) ;
            backButton = new JButton(
                     new ImageIcon( ClassLoader.getSystemResource(icons[2])) ) ;
            forwardButton = new JButton(
                     new ImageIcon( ClassLoader.getSystemResource(icons[3])) ) ;

            homeButton.addActionListener(this) ;
            backButton.addActionListener(this) ;
            forwardButton.addActionListener(this) ;

            backButton.setEnabled(false) ;
            forwardButton.setEnabled(false) ;

            toolBar.add( homeButton ) ;
            toolBar.add( backButton ) ;
            toolBar.add( forwardButton ) ;

            getContentPane().add(toolBar, BorderLayout.NORTH) ;            
            getContentPane().add(jsp, BorderLayout.CENTER) ;
         } 
      } catch (MalformedURLException e) { 
         System.out.println("Malformed URL: " + e); 
      } catch (IOException e) { 
         System.out.println("IOException: " + e); 
      } 

      show() ;
  }
    
  /**
   * Implementation of the ActionListener method. It processes buttons' actions
   */  
   public void actionPerformed(ActionEvent e) {
      JButton button = (JButton) e.getSource() ;   // care must be taken here
      if (button == homeButton) {
            // remove every link except the first one, and show the first one
         try {
            URL url= (URL) list.getFirst() ;
            list.removeAll(list) ;
            list.add(url) ;
            html.setPage( url ) ;
            visited = 0 ;
            backButton.setEnabled(false) ;
            forwardButton.setEnabled(false) ;
         } catch (Exception ex) {
            ex.printStackTrace() ;
         }
      } else if (button == backButton) {
         if (visited > 0) {
            try {
               visited-- ;
               html.setPage( (URL) list.get(visited) ) ;
               forwardButton.setEnabled(true) ;
            } catch (Exception ex) {
               ex.printStackTrace() ;
            }
         }
      } else if (button == forwardButton) {
         if (visited < size-1) {
            try {
               visited++ ;
               html.setPage( (URL) list.get(visited) ) ;
            } catch (Exception ex) {
               ex.printStackTrace() ;
            }
         }
      }
   }  // close method 

  /**
   * This method returns an implementation of the HyperlinkListener listener
   */  
  public HyperlinkListener createHyperLinkListener() { 
	   return new HyperlinkListener() { 
	      public void hyperlinkUpdate(HyperlinkEvent e) { 
		      if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) { 
			      try { 
			         html.setPage(e.getURL()); 
                  list.add(e.getURL()) ;
                  size = list.size() ;
                  visited = size - 1 ;
                  backButton.setEnabled(true) ;
			      } catch (IOException ex) { 
			         System.out.println("IOException: " + ex); 
			      } 
		      } 
	      } 
	   }; 
  }       
} 
